Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0002315opensim[REGION] OpenSim Corepublic2008-10-02 10:262008-12-10 08:53
Reporterbpanacek 
Assigned Tojustincc 
PrioritynormalSeverityminorReproducibilityalways
StatusclosedResolutionfixed 
PlatformOperating SystemOperating System Version
Product Version 
Target VersionFixed in Version 
Summary0002315: Imported Second Life Terrain Map RAW file renders as mirror image of SL terrain.
DescriptionTerrain RAW file exported from SL is rendered as a mirror image. Heights appear to be correct, but the map itself is backwards.
Additional InformationCompare attached file in OpenSim to "Poitou Coeur" in SL.
TagsNo tags attached.
Git Revision or version number
Run ModeStandalone (1 Region)
Physics EngineBasicPhysics
Script Engine
Environment.NET / Windows32
Mono Version
Viewer
Attached Files? file icon PoitouTerrain081002.raw [^] (851,968 bytes) 2008-10-02 10:26
patch file icon 2315_raw_loader.patch [^] (2,239 bytes) 2008-10-02 13:03 [Show Content]
patch file icon terrain_flip.patch [^] (2,118 bytes) 2008-12-05 13:24 [Show Content]
patch file icon terrain_flip_x_and_y.patch [^] (3,135 bytes) 2008-12-05 13:41 [Show Content]

- Relationships

-  Notes
(0005615)
jonc (reporter)
2008-10-02 13:03

Y direction is inverted compared with region on SL grid.

Attaching a patch to load and save .raw files with y offset in the heightmap flipped.

supplied .raw file now orientates the same in OpenSim and SL grid
(0005638)
Fly-Man- (developer)
2008-10-03 10:22

Patch tested: Looks good, Island is now turned around and looks like the SL version
(0005639)
justincc (administrator)
2008-10-03 10:45
edited on: 2008-10-03 10:45

I have a vague feeling this has been discussed before and that there might be some kind of reason for this. Or I could just be going senile. Going to assign to Adam - I think he should be able to say what the case is.

(0005640)
idb (manager)
2008-10-03 11:06

I tried a raw file from http://www.archive.org/details/Sample_RAW_File [^] brilliant_terrain.raw
The north east corner looked different in SL but the land was rendered the correct way round and also looked the same as viewing the raw file with the Bailiwick raw file editor.
(0005852)
justincc (administrator)
2008-10-10 13:38

Is this going to mean that everybody who has already saved out terrain using OpenSim is going to find their reload now flips it the wrong way. Is there any way around this? Is this important?
(0005853)
bpanacek (reporter)
2008-10-10 13:49

It appears that the issue is whether SL is exporting it flipped the wrong way and importing it the correct way. I have not used the SL beta grid, but perhaps I can import the same map and see if it is reversed. If it is, then they have an export problem that needs to be fixed (otherwise, you cannot truly do a backup). In any case, it appears I will need to find a way to flip the map so I can prototype in OpenSim.
(0005855)
jonc (reporter)
2008-10-10 13:57

It would be possible to add a terrain rotate command - not sure this is the best approach though.
(0005856)
bpanacek (reporter)
2008-10-10 13:59

It's not an orientation issue. It's flipped on only one axis.
(0005857)
justincc (administrator)
2008-10-10 14:01

Okay - I've asked Adam for feedback (it's possible he didn't see the assignment or it simply got lost amongst the masses of e-mail he probably gets). Otherwise I'll consider what the best way forward is, because it does sound like something that needs to be fixed.
(0005858)
bpanacek (reporter)
2008-10-10 14:06

Perhaps a switch to correct the SL Y axis flip or changing the extension of the RAW file to indicate that it is an SL RAW file which doesn't conform to a standard. In any case, I'll see if there is a way to see if SL can import an exported file (though not on my production sim! :).
(0007569)
lbsa71 (administrator)
2008-12-05 05:44

After some discussion on the mailing list, I will go ahead and patch trunk and stable with this (it's a really simple fix) - and we'll try to incorporate a 'terrain flip y' for the cases that need it.
(0007570)
justincc (administrator)
2008-12-05 05:46

Actually, I think on this one we are better off waiting for the flipping code first.
(0007571)
justincc (administrator)
2008-12-05 06:33

jonc, is there any chance you could supply a patch for a terrain flip command in the core terrain module? Something like "terrain flip <x|y>" I think, since I'm guessing it would be odd to be able to flip on the y axis but not the x.

If anybody else wants to do such a patch, then it looks like the relevant code can be seen in

http://forge.opensimulator.org/gf/project/terraintools/scmsvn/?action=browse&path=%2Ftrunk%2FOpenSim%2FRegion%2FEnvironment%2FModules%2FWorld%2FTerrain%2FTerrainTools.cs&revision=13&view=markup [^]

search for FlipHeightMap(). If we apply a patch from code taken from here then don't forget to put jonc in the CONTRIBUTORS.txt for copyright purposes (as well as yourself, potentially).
(0007586)
jonc (reporter)
2008-12-05 13:23

attaching 'terrain flip' patch
(0007587)
jonc (reporter)
2008-12-05 13:43
edited on: 2008-12-06 13:42

terrain_flip_x_and_y.patch allows 'flipping' in both the x and y directions as per comment 0007571. Use this instead of terrain_flip.patch - which just does y.

(0007705)
justincc (administrator)
2008-12-09 09:10

Applied the terrain_flip_x_and_y.patch in r7650. Thanks jonc!
(0007708)
justincc (administrator)
2008-12-09 09:18

Holding off on applying 2315_raw_loader.patch until the users mailing list is working again, so that users can be advised on how to flip their existing textures. This change doesn't appear to affect oars since they use .r32 rather than .raw (the extension used by LLRAW).
(0007721)
justincc (administrator)
2008-12-10 08:53

Okay, I have now applied the original patch in r7654. There is also a users/dev mailing list entry about this, telling people that they may need to do a "terrain flip y" for their old RAW terrains.

Thanks jonc!

- Issue History
Date Modified Username Field Change
2008-10-02 10:26 bpanacek New Issue
2008-10-02 10:26 bpanacek File Added: PoitouTerrain081002.raw
2008-10-02 10:26 bpanacek SVN Revision => 0.5.9
2008-10-02 10:26 bpanacek Run Mode => Standalone (1 Region)
2008-10-02 10:26 bpanacek Physics Engine => BasicPhysics
2008-10-02 10:26 bpanacek Environment => .NET / Windows32
2008-10-02 13:03 jonc Note Added: 0005615
2008-10-02 13:03 jonc File Added: 2315_raw_loader.patch
2008-10-02 15:50 jonc Status new => patch included
2008-10-03 10:22 Fly-Man- Note Added: 0005638
2008-10-03 10:45 justincc Note Added: 0005639
2008-10-03 10:45 justincc Status patch included => assigned
2008-10-03 10:45 justincc Assigned To => AdamFrisby
2008-10-03 10:45 justincc Note Edited: 0005639
2008-10-03 11:06 idb Note Added: 0005640
2008-10-10 13:38 justincc Note Added: 0005852
2008-10-10 13:38 justincc Status assigned => feedback
2008-10-10 13:49 bpanacek Note Added: 0005853
2008-10-10 13:57 jonc Note Added: 0005855
2008-10-10 13:59 bpanacek Note Added: 0005856
2008-10-10 14:01 justincc Note Added: 0005857
2008-10-10 14:06 bpanacek Note Added: 0005858
2008-12-05 05:40 lbsa71 Status feedback => assigned
2008-12-05 05:40 lbsa71 Assigned To AdamFrisby => lbsa71
2008-12-05 05:44 lbsa71 Note Added: 0007569
2008-12-05 05:46 justincc Note Added: 0007570
2008-12-05 06:33 justincc Note Added: 0007571
2008-12-05 13:23 jonc Note Added: 0007586
2008-12-05 13:24 jonc File Added: terrain_flip.patch
2008-12-05 13:41 jonc File Added: terrain_flip_x_and_y.patch
2008-12-05 13:43 jonc Note Added: 0007587
2008-12-06 13:42 jonc Note Edited: 0007587
2008-12-09 09:10 justincc Note Added: 0007705
2008-12-09 09:13 justincc Assigned To lbsa71 => justincc
2008-12-09 09:18 justincc Note Added: 0007708
2008-12-10 08:53 justincc Status assigned => closed
2008-12-10 08:53 justincc Note Added: 0007721
2008-12-10 08:53 justincc Resolution open => fixed


Copyright © 2000 - 2012 MantisBT Group
Powered by Mantis Bugtracker